SystemOrganization addCategory: #ConfigurationOfCog!

Object subclass: #ConfigurationOfCog
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfCog'!

!ConfigurationOfCog class methodsFor: 'private' stamp: 'jb 11/9/2010 13:56'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfCog class methodsFor: 'private' stamp: 'jb 11/9/2010 13:56'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfCog class methodsFor: 'metacello tool support' stamp: 'jb 11/9/2010 13:56'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfCog class methodsFor: 'metacello tool support' stamp: 'jb 11/9/2010 13:56'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfCog class methodsFor: 'loading' stamp: 'jb 11/9/2010 13:56'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfCog class methodsFor: 'metacello tool support' stamp: 'jb 11/9/2010 13:56'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfCog class methodsFor: 'accessing' stamp: 'jb 11/9/2010 13:56'!
project

	^self new project! !

!ConfigurationOfCog methodsFor: 'baselines' stamp: 'jb 11/10/2010 14:31'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.		
				
		spec repository: 'http://source.squeak.org/FFI';	
			  package: 'FFI-Pools'.
			
		spec repository: 'http://www.squeaksource.com/Speech';	
			  package: 'SharedPool-Speech'.
		
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Balloon-Engine-Pools'.
		
			
		spec repository: 'http://www.squeaksource.com/Alien';	
			  package: 'Alien-Core' with: [spec requires: #('Alien-Prereqs')];
			  package: 'Alien-Prereqs'.
			
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Cog' with: [ spec requires: #('VMMaker' ) ].	
			
		spec repository: 'http://www.squeaksource.com/VMMaker';
			  package: 'VMMaker' with: [ spec requires: #('SharedPool-Speech' 'FFI-Pools' 'Balloon-Engine-Pools' ) ].
			
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Qwaq-VMProfiling-Plugins' with: [ spec requires: #('VMMaker' ) ].
			
		spec postLoadDoIt: #fixForPharo10.
		].! !

!ConfigurationOfCog methodsFor: 'baselines' stamp: 'IgorStasenko 2/4/2011 11:06'!
baseline12: spec 
	" Alien-Prereqs are no longer used "
	<version: '1.2-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.		
				
		spec repository: 'http://source.squeak.org/FFI';	
			  package: 'FFI-Pools'.
			
		spec repository: 'http://www.squeaksource.com/Speech';	
			  package: 'SharedPool-Speech'.
		
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Balloon-Engine-Pools'.
		
		spec repository: 'http://www.squeaksource.com/Alien';	
			  package: 'Alien-Core'.

		spec repository: 'http://www.squeaksource.com/PharoSound';
			package: 'Sound'.
						
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Cog' with: [ spec requires: #('VMMaker' ) ].	
			
		spec repository: 'http://www.squeaksource.com/VMMaker';
			  package: 'VMMaker' with: [ spec requires: #('SharedPool-Speech' 'FFI-Pools' 'Balloon-Engine-Pools' 'Sound' ) ].
			
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Qwaq-VMProfiling-Plugins' with: [ spec requires: #('VMMaker' ) ].
			
		spec postLoadDoIt: #fixForPharo10.
		].! !

!ConfigurationOfCog methodsFor: 'baselines' stamp: 'EstebanLorenzano 3/1/2011 13:10'!
baseline13: spec 
	" Alien-Prereqs are no longer used "
	<version: '1.3-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.		
				
		spec repository: 'http://source.squeak.org/FFI';	
			  package: 'FFI-Pools'.
			
		spec repository: 'http://www.squeaksource.com/Speech';	
			  package: 'SharedPool-Speech'.
		
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Balloon-Engine-Pools'.
		
		spec repository: 'http://www.squeaksource.com/Alien';	
			  package: 'Alien-Core'.

		spec repository: 'http://www.squeaksource.com/PharoSound';
			package: 'Sound'.
						
		spec repository: 'http://www.squeaksource.com/VMMaker';	
			  package: 'Cog' with: [ spec requires: #('VMMaker-oscog' ) ].	
			
		spec repository: 'http://www.squeaksource.com/VMMaker';
			  package: 'VMMaker-oscog' with: [ spec requires: #('SharedPool-Speech' 'FFI-Pools' 'Balloon-Engine-Pools' 'Sound' ) ].
			
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Qwaq-VMProfiling-Plugins' with: [ spec requires: #('VMMaker-oscog' ) ].
			
		spec postLoadDoIt: #fixForPharo10.
		].! !

!ConfigurationOfCog methodsFor: 'baselines' stamp: 'MarianoMartinezPeck 3/30/2011 19:29'!
baseline14: spec 
	" Alien-Prereqs are no longer used "
	<version: '1.4-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.		
				
		spec repository: 'http://source.squeak.org/FFI';	
			  package: 'FFI-Pools'.
			
		spec repository: 'http://www.squeaksource.com/Speech';	
			  package: 'SharedPool-Speech'.
		
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Balloon-Engine-Pools'.
		
		spec repository: 'http://www.squeaksource.com/Alien';	
			  package: 'Alien-Core'.

		spec repository: 'http://www.squeaksource.com/PharoSound';
			package: 'Sound'.
						
		spec repository: 'http://www.squeaksource.com/VMMaker';	
			  package: 'Cog' with: [ spec requires: #('VMMaker-oscog' ) ].	
			
		spec repository: 'http://www.squeaksource.com/VMMaker';
			  package: 'VMMaker-oscog' with: [ spec requires: #('SharedPool-Speech' 'FFI-Pools' 'Balloon-Engine-Pools' 'Sound' ) ].
			
		spec repository: 'http://www.squeaksource.com/JBARepo';	
			  package: 'Qwaq-VMProfiling-Plugins' with: [ spec requires: #('VMMaker-oscog' ) ].
			
		spec repository: 'http://www.squeaksource.com/VMMaker';	
			  package: 'CMakeVMMaker' with: [spec requires: #('Cog') ] .
			
		spec postLoadDoIt: #fixForPharo10.
		].! !

!ConfigurationOfCog methodsFor: 'doits' stamp: 'IgorStasenko 2/3/2011 11:34'!
fixForPharo10
	self fixVMMakerForPharo.
	! !

!ConfigurationOfCog methodsFor: 'doits' stamp: 'jb 11/9/2010 13:56'!
fixFreeTypePluginForPharo
(Smalltalk at:#FT2Plugin) class compile: 
	'declareCVarsIn: cg
	cg addHeaderFile: ''<ft2build.h>''.
	cg addHeaderFile: ''<freetype/tttables.h>''.
	cg addHeaderFile: ''FT_FREETYPE_H''.
	cg addHeaderFile: ''FT_OUTLINE_H''.
	cg var: ''library'' declareC: ''FT_Library library''.
	cg var: ''errorCode'' type: ''int''.'! !

!ConfigurationOfCog methodsFor: 'doits' stamp: 'IgorStasenko 2/4/2011 16:29'!
fixVMMakerForPharo
"fix VMMaker to fix bug"

"yeah, we need that "
Author fullName: 'MrVMMaker'.


ByteString compile: 'findSubstring: key in: body startingAt: start matchTable: matchTable
	"Answer the index in the string body at which the substring key first occurs, at or beyond start.  The match is determined using matchTable, which can be used to effect, eg, case-insensitive matches.  If no match is found, zero will be returned.

	The algorithm below is not optimum -- it is intended to be translated to C which will go so fast that it wont matter."
	| index |
	<primitive: ''primitiveFindSubstring'' module: ''MiscPrimitivePlugin''>
	
	<var: #key declareC: ''unsigned char *key''>
	<var: #body declareC: ''unsigned char *body''>
	<var: #matchTable declareC: ''unsigned char *matchTable''>

	key size = 0 ifTrue: [^ 0].
	start to: body size - key size + 1 do:
		[:startIndex |
		index := 1.
			[(matchTable at: (body at: startIndex+index-1) asciiValue + 1)
				= (matchTable at: (key at: index) asciiValue + 1)]
				whileTrue:
				[index = key size ifTrue: [^ startIndex].
				index := index+1]].
	^ 0
'.

Author reset.


! !

!ConfigurationOfCog methodsFor: 'doits' stamp: 'IgorStasenko 2/3/2011 16:01'!
pharoUndescoreAssignment
"in recent image that authorize underscore assignment because we load some squeak code in VMMaker if the preference is not set in this way the image should be compatible with underscore assigment"
" [Scanner allowUnderscoreAsAssignment: true.] on: Exception do: [].
"! !

!ConfigurationOfCog methodsFor: 'accessing' stamp: 'jb 11/9/2010 13:56'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'jb 11/10/2010 13:38'!
version10: spec 
	<version: '1.0' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-ar.1';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'VMMaker' with: 'VMMaker-oscog.16';
			package: 'Alien-Prereqs' with: 'Alien-Prereqs-KenTreis.5';
			package: 'Alien-Core' with: 'Alien-Core-FernandoOlivero.64';
			package: 'Cog' with: 'Cog-JB.41'.
			
	].		! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'jb 11/10/2010 13:38'!
version11: spec 
	<version: '1.1' imports: #('1.0-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-ar.1';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'VMMaker' with: 'VMMaker-Igor.Stasenko.37';
			package: 'Alien-Prereqs' with: 'Alien-Prereqs-KenTreis.5';
			package: 'Alien-Core' with: 'Alien-Core-FernandoOlivero.64';
			package: 'Cog' with: 'Cog-JB.41'.
			
	].		! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'IgorStasenko 2/4/2011 11:06'!
version12: spec 
	<version: '1.2' imports: #('1.2-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-eem.2';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'Sound' with: 'Sound-StephaneDucasse.62';
			package: 'VMMaker' with: 'VMMaker-oscog-Igor.Stasenko.48';
			package: 'Alien-Core' with: 'Alien-Core-IgorStasenko.68';
			package: 'Cog' with: 'Cog-JB.41'.
			
	].		! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'EstebanLorenzano 3/1/2011 13:09'!
version13: spec 
	<version: '1.3' imports: #('1.3-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-eem.2';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'Sound' with: 'Sound-StephaneDucasse.62';
			package: 'VMMaker-oscog' with: 'VMMaker-oscog-IgorStasenko.Stasenko.49';
			package: 'Alien-Core' with: 'Alien-Core-IgorStasenko.68';
			package: 'Cog' with: 'Cog-eem.44'.
			
	].		! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'IgorStasenko 3/18/2011 15:52'!
version14: spec 
	<version: '1.4' imports: #('1.3-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'Sound' with: 'Sound-StephaneDucasse.62';
			package: 'VMMaker-oscog' with: 'VMMaker-oscog.52';
			package: 'Alien-Core' with: 'Alien-Core-IgorStasenko.68';
			package: 'Cog' with: 'Cog-eem.44'.
			
	].		! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'IgorStasenko 3/23/2011 17:58'!
version15: spec 
	<version: '1.5' imports: #('1.3-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'Sound' with: 'Sound-StephaneDucasse.62';
			package: 'VMMaker-oscog' with: 'VMMaker-oscog-IgorStasenko.54';
			package: 'Alien-Core' with: 'Alien-Core-IgorStasenko.68';
			package: 'Cog' with: 'Cog-eem.44'.
			
	].		! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'IgorStasenko 4/11/2011 14:29'!
version16: spec 
	<version: '1.6' imports: #('1.4-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'Sound' with: 'Sound-StephaneDucasse.62';
			package: 'VMMaker-oscog' with: 'VMMaker-oscog-IgorStasenko.56';
			package: 'Alien-Core' with: 'Alien-Core-IgorStasenko.68';
			package: 'Cog' with: 'Cog-eem.44';
			package: 'CMakeVMMaker' with: 'CMakeVMMaker-IgorStasenko.74'.
	].		! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'IgorStasenko 4/12/2011 13:29'!
version17: spec 
	<version: '1.7' imports: #('1.4-baseline') >
	
	spec for: #common do: [
		spec blessing: #release.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'Sound' with: 'Sound-StephaneDucasse.62';
			package: 'VMMaker-oscog' with: 'VMMaker-oscog.dtl.57';
			package: 'Alien-Core' with: 'Alien-Core-IgorStasenko.68';
			package: 'Cog' with: 'Cog-eem.44';
			package: 'CMakeVMMaker' with: 'CMakeVMMaker-IgorStasenko.78'.
	].! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'MarianoMartinezPeck 4/23/2011 16:17'!
version18: spec 
	<version: '1.8' imports: #('1.4-baseline') >
	
	spec for: #common do: [
		spec blessing: #development.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'Sound' with: 'Sound-StephaneDucasse.62';
			package: 'VMMaker-oscog' with: 'VMMaker-oscog-MarianoMartinezPeck.66';
			package: 'Alien-Core' with: 'Alien-Core-IgorStasenko.68';
			package: 'Cog' with: 'Cog-eem.44';
			package: 'CMakeVMMaker' with: 'CMakeVMMaker-EstebanLorenzano.96'.
	].! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'EstebanLorenzano 4/25/2011 20:01'!
version19: spec 
	<version: '1.9' imports: #('1.8') >
	
	spec for: #common do: [
		spec blessing: #development.
		spec 
			package: 'VMMaker-oscog' with: 'VMMaker-oscog-MarianoMartinezPeck.66';
			package: 'CMakeVMMaker' with: 'CMakeVMMaker-MarianoMartinezPeck.99'.
	].! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'IgorStasenko 5/3/2011 16:05'!
version20: spec 
	<version: '2.0' imports: #('1.4-baseline') >
	
	spec for: #common do: [
		spec blessing: #development.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'Sound' with: 'Sound-StephaneDucasse.62';
			package: 'VMMaker-oscog' with: 'VMMaker-oscog-MarianoMartinezPeck.66';
			package: 'Alien-Core' with: 'Alien-Core-IgorStasenko.68';
			package: 'Cog' with: 'Cog-eem.44';
			package: 'CMakeVMMaker' with: 'CMakeVMMaker-IgorStasenko.103'.
	].! !

!ConfigurationOfCog methodsFor: 'versions' stamp: 'IgorStasenko 6/29/2011 04:49'!
version21: spec 
	<version: '2.1' imports: #('1.4-baseline') >
	
	spec for: #common do: [
		spec blessing: #development.
		spec 
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'SharedPool-Speech' with: 'SharedPool-Speech-dtl.2';
			package: 'Balloon-Engine-Pools' with: 'Balloon-Engine-Pools-JB.2';
			package: 'Qwaq-VMProfiling-Plugins' with: 'Qwaq-VMProfiling-Plugins-JB.5';
			package: 'Sound' with: 'Sound-StephaneDucasse.62';
			package: 'VMMaker-oscog' with: 'VMMaker-oscog-IgorStasenko.90';
			package: 'Alien-Core' with: 'Alien-Core-IgorStasenko.68';
			package: 'Cog' with: 'Cog-eem.44';
			package: 'CMakeVMMaker' with: 'CMakeVMMaker-IgorStasenko.109'.
	].! !
